// smart_assert_print.hpp

// Boost.SmartAssert library
//
// Copyright (C) 2003 John Torjo (john@torjo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
 
// See http://www.boost.org for updates, documentation, and revision history.

#ifndef BOOST_INNER_SMART_ASSERT_PRINT_HPP_INCLUDED
#define BOOST_INNER_SMART_ASSERT_PRINT_HPP_INCLUDED

#include "smart_assert_context.hpp"

namespace boost { 

namespace smart_assert {


// classes for printing the variables that
// are involved in an ASSERT, in case the ASSERT fails
struct default_printer {

    template< class type>
    int print_val( assert_context & context, const type & val, const char * str) {
        std::ostringstream out;
        out << val;
        
        return context.add_val( out.str(), str);
    }

};

} // namespace smart_assert

} // namespace boost


#endif
