// smart_enforce.h

// Boost.SmartAssert library
//
// Copyright (C) 2003 John Torjo (john@torjo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
 
// See http://www.boost.org for updates, documentation, and revision history.

#ifndef BOOST_INNER_SMART_VERIFY_HPP_INCLUDED
#define BOOST_INNER_SMART_VERIFY_HPP_INCLUDED

#include "boost/smart_assert/smart_assert.hpp"

namespace boost {

namespace smart_assert {

// works in Release mode as well !!!
//
// if the ASSERTion fails, it's treated as an ERROR
// (which means that by default, a std::runtime_error will be triggered)
#define SMART_VERIFY(expr) \
    if ( boost::smart_assert::Private::keeper boost_private_assert_keeper = 0) ; else \
    if ( boost_private_assert_keeper.test_expr((expr),#expr) ) ; else \
        boost::smart_assert::make_assert().error().SMART_ASSERT_CONTEXT.print_prewrittern_values( boost_private_assert_keeper).SMART_ASSERT_A \
    /**/



} // namespace smart_assert

} // namespace boost

#endif
