// static_initializer.hpp

// Boost.SmartAssert library
//
// Copyright (C) 2003 John Torjo (john@torjo.com)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
 
// See http://www.boost.org for updates, documentation, and revision history.

#ifndef BOOST_INNER_STATIC_INITIALIZER_HPP_INCLUDED
#define BOOST_INNER_STATIC_INITIALIZER_HPP_INCLUDED

namespace boost {

namespace smart_assert {

/* 
    helper - allow calling a given function 
    BEFORE main
    (in other words, allow calling a function when we're sure
     we're the only thread)

    In order to benefit from this, derive from it,
    as private

    
    Use it, for instance, when you have a function returning
    a static variable and you want to be sure that static 
    was initialized correctly.
*/
class initializer {

protected:
    initializer()
    {}
public:
};


} // namespace smart_assert

} // namespace boost

#endif
